#include "console_intro.h"

ConsoleIntro::ConsoleIntro()
{
    width = 72;
    height = 10;
    border_char = '*';

    title = "Welcome to the Number Adding Program!";
    author = "Jason Lillywhite";
    organization = "GoldSim Technology Group";
    date = "03/15/2020";
    version = 1.00;
}

string ConsoleIntro::tab(int count)
{
	return string(count, '\t');
}

string ConsoleIntro::row(char c, int count)
{
    string string_of_chars;
    for (int i = 0; i < count; i++)
    {
        string_of_chars += c;
    }
    return string_of_chars;
}

string ConsoleIntro::column()
{
    string string_of_chars = "";
    int count = (height - 5) / 2;
    for (int i = 0; i < count; i++)
    {
        string_of_chars += border_char;
        //string_of_chars += row('\t', 9);
        //string_of_chars += tab(9);
        //string_of_chars += c;
        string_of_chars += '\n';
    }
    return string_of_chars;
}

void ConsoleIntro::print()
{
    int white_space;
    // First row
    white_space = (width - title.length() - 2) / 2;
    body += row(border_char, white_space);
    body += ' ';
    body += title;
    body += ' ';
    body += row(border_char, white_space);
    body += '\n';

    // Spacer rows
    body += column();

    // Print Author
    body += border_char;
    white_space = (width - (13 + author.length() + organization.length())) / 2;
    body += row(' ', white_space);
    body += "Written by " + author + ", " + organization;
    body += row(' ', white_space);
    body += '\n';

    // Print date
    body += border_char;
    white_space = (width - date.length()) / 2;
    body += row(' ', white_space);
    body += date;
    body += row(' ', white_space);
    body += '\n';

    // Print version
    body += border_char;
    white_space = (width - 12) / 2;
    body += row(' ', white_space);
    body += "Version ";
    std::ostringstream ss;
    ss << std::fixed << std::setprecision(2) << version;
    body += ss.str();
    body += row(' ', white_space);
    body += '\n';

    // Spacer rows
    body += column();

    // Final row
    body += row('*', width) += "\n\n";

    std::cout << body;
}
